/*
 * This file was generated by qdbusxml2cpp version 0.7
 * Command line was: qdbusxml2cpp -p proxy dbus.xml
 *
 * qdbusxml2cpp is Copyright (C) 2015 The Qt Company Ltd.
 *
 * This is an auto-generated file.
 * Do not edit! All changes made to it will be lost.
 */

#ifndef PROXY_H_1601986678
#define PROXY_H_1601986678

#include <QtCore/QObject>
#include <QtCore/QByteArray>
#include <QtCore/QList>
#include <QtCore/QMap>
#include <QtCore/QString>
#include <QtCore/QStringList>
#include <QtCore/QVariant>
#include <QtDBus/QtDBus>

/*
 * Proxy class for interface org.bluez.mesh.Provisioner1
 */
class OrgBluezMeshProvisioner1Interface: public QDBusAbstractInterface
{
    Q_OBJECT
public:
    static inline const char *staticInterfaceName()
    { return "org.bluez.mesh.Provisioner1"; }

public:
    OrgBluezMeshProvisioner1Interface(const QString &service, const QString &path, const QDBusConnection &connection, QObject *parent = 0);

    ~OrgBluezMeshProvisioner1Interface();

public Q_SLOTS: // METHODS
    inline QDBusPendingReply<> AddNodeComplete(const QByteArray &uuid, ushort unicast, uchar count)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(uuid) << QVariant::fromValue(unicast) << QVariant::fromValue(count);
        return asyncCallWithArgumentList(QLatin1String("AddNodeComplete"), argumentList);
    }

    inline QDBusPendingReply<> AddNodeFailed(const QByteArray &uuid, const QString &reason)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(uuid) << QVariant::fromValue(reason);
        return asyncCallWithArgumentList(QLatin1String("AddNodeFailed"), argumentList);
    }

    inline QDBusPendingReply<ushort, ushort> RequestProvData(uchar count)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(count);
        return asyncCallWithArgumentList(QLatin1String("RequestProvData"), argumentList);
    }
    inline QDBusReply<ushort> RequestProvData(uchar count, ushort &unicast)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(count);
        QDBusMessage reply = callWithArgumentList(QDBus::Block, QLatin1String("RequestProvData"), argumentList);
        if (reply.type() == QDBusMessage::ReplyMessage && reply.arguments().count() == 2) {
            unicast = qdbus_cast<ushort>(reply.arguments().at(1));
        }
        return reply;
    }

    inline QDBusPendingReply<> ScanResult(short rssi, const QByteArray &data, const QVariantMap &options)
    {
        QList<QVariant> argumentList;
        argumentList << QVariant::fromValue(rssi) << QVariant::fromValue(data) << QVariant::fromValue(options);
        return asyncCallWithArgumentList(QLatin1String("ScanResult"), argumentList);
    }

Q_SIGNALS: // SIGNALS
};

namespace org {
  namespace bluez {
    namespace mesh {
      typedef ::OrgBluezMeshProvisioner1Interface Provisioner1;
    }
  }
}
#endif
